#include <stdio.h>
#include <conio.h>

#define kbEsc   27
#define kbLeft  75
#define kbRight 77
#define kbUp    72
#define kbDn    80

struct punkt
{int x, y;
};

void przesun(punkt&, int, int);
void wyswietl(const punkt*);
void wspolrzedne(const punkt*, int, int);
void komunikat(const char*, int, int);
void narysuj (const punkt);

void main()
{  punkt p={1, 1};
   char opcja;
   _setcursortype(_NOCURSOR);
   clrscr();
   printf("Jesli nacisniesz jeden z klawiszy:\n");
   printf(" strzalka w prawo, strzalka w lewo, strzalka w gore, strzalka w dol \n");
	 printf("k,Esc - Koniec programu\n");
	 narysuj(p);
	 wspolrzedne(&p,2,23);
	 do
	 {
	  opcja=getch();
	  if (opcja==0)
	     opcja=getch();
	  switch(opcja)
	   { case kbLeft  : przesun(p,-1,0);		 break;
	     case kbRight : przesun(p,1,0); 		 break;
	     case kbUp    : przesun(p,0,-1);		 break;
	     case kbDn    : przesun(p,0,1); 		 break;
	     case 'k': case kbEsc :
		komunikat("Nacisnales klawisz Esc lub k - koniec programu",2,24); break;
 	     default : komunikat("Nacisnales niewlasciwy klawisz",2,24);
	   }
	narysuj(p);
	wspolrzedne(&p,2,23);
    }while (opcja!=kbEsc && opcja!='k');
    _setcursortype(_NORMALCURSOR);
}

void przesun(punkt& p, int x, int y)
{
	if ((p.x + x)>0 && (p.x+x)<=80)
		p.x+=x;
	if ((p.y + y)>0 && (p.y+y)<=17)
		p.y+=y;
}

void wyswietl(const punkt* p)
{
	printf("x=%i, y=%i",p->x, p->y);
}

void wspolrzedne(const punkt* p, int x, int y)
{
		gotoxy(x,y);		wyswietl(p);
		while(!kbhit());
}

void komunikat(const char* lan, int x, int y)
{
		gotoxy(x,y);		printf(lan);
		while(!kbhit());
		gotoxy(x,y);		clreol();
}

void narysuj (const punkt p)
{
		window(1,5,80,22);
		clrscr();
		gotoxy(p.x,p.y); puts("*");
		window(1,1,80,25);

}